﻿Imports Colour_Blocks.MainForm

Public Class Shop

    Public itemType As ShopItem.Type
    Public TRepItem As New ShopItem
    Public CurrentItem As New ShopItem
    Public originalLocation As Point
    Public currentMousePoint As Point
    Public locationDifference_X As Integer
    Public locationDifference_Y As Integer
    Public currentWidth As Integer
    Public WidthDiff As Integer
    Public currentHeight As Integer
    Public HeightDiff As Integer

    Public newAction As New Action

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FormDragTimer.Tick
        Me.Location = New Point(MousePosition.X + locationDifference_X, MousePosition.Y + locationDifference_Y)

    End Sub

    Private Sub title_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Titlebar.MouseDown
        originalLocation = Me.Location
        currentMousePoint = MousePosition

        locationDifference_Y = originalLocation.Y - currentMousePoint.Y
        locationDifference_X = originalLocation.X - currentMousePoint.X

        FormDragTimer.Enabled = True

    End Sub

    Private Sub title_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Titlebar.MouseUp
        FormDragTimer.Enabled = False

    End Sub

    Private Sub btnExit_MouseEnter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.MouseEnter
        btnExit.BackgroundImage = My.Resources.EXIT_hover

    End Sub

    Private Sub btnExit_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnExit.MouseDown
        btnExit.BackgroundImage = My.Resources.EXIT_clicked

    End Sub

    Private Sub btnExit_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.MouseLeave
        btnExit.BackgroundImage = My.Resources._EXIT

    End Sub

    Public myItems As New Items

    Public WeaponsShop As New WeaponShop
    Public AmmoShop As New AmmoShop
    Public ArmourShop As New ArmourShop
    Public ConsumableShop As New Consumables




    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Close()
    End Sub


    Private Sub Shop_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lblCoins.Text = MainForm.myCoins
        lblDiamonds.Text = MainForm.myDiamonds

    End Sub


    Private Sub cmbCategory_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbCategory.SelectedIndexChanged
        If cmbCategory.SelectedItem = "Weapons" Then
            lbItems.Items.Clear()
            lbItems.Items.AddRange(New Object() {"Pistol", "Super Pistol", "Laser Pistol", "Double-Charged Surge Gun", "Emblazoned Thunder Gun", "Flame Infused Machine Gun"})
        ElseIf cmbCategory.SelectedItem = "Ammo" Then
            lbItems.Items.Clear()
            lbItems.Items.AddRange(New Object() {"Bullet", "Power Bullet", "Heavy Bullet", "Enhanced Bullet", "Destructive Bullet"})
        ElseIf cmbCategory.SelectedItem = "Consumable" Then
            lbItems.Items.Clear()
            lbItems.Items.AddRange(New Object() {"Potion", "Major Potion", "Enhanced Potion", "Super Potion", "Greater Potion"})
        ElseIf cmbCategory.SelectedItem = "Armour" Then
            lbItems.Items.Clear()
            lbItems.Items.AddRange(New Object() {"Heavy Blue Helm", "Heavy Blue Chestplate", "Heavy Blue Leggings", "Heavy Blue Boots", "Royal Blue Helm", "Royal Blue Chestplate", "Royal Blue Leggings", "Royal Blue Boots", "Marine Helm", "Marine Chestplate", "Marine Leggings", "Marine Boots", "Darkened Seahelm", "Darkened Seaplate", "Darkened Sea Trousers", "Darkened Sea Boots"})
        End If

    End Sub

    Private Sub lbItems_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbItems.SelectedIndexChanged
        ResetCurrentlyEquippedValues()
        myItems.ItemName = lbItems.SelectedItem
        myItems.CheckItem()
        ReturnItemValues()

    End Sub

    Public Sub ReturnItemValues()
        Dim continueExecution As Boolean

        imgItem.BackgroundImage = myItems.Item.Image
        itemType = myItems.Item.ItemType
        lblName.Text = myItems.Item.Title
        If myItems.Item.Health = 0 Then
            lblHealth.Visible = False
        Else
            lblHealth.Visible = True
            lblHealth.Text = "+" & myItems.Item.Health & " Health"
        End If
        If myItems.Item.Accuracy = 0 Then
            lblAccuracy.Visible = False
        Else
            lblAccuracy.Visible = True
            lblAccuracy.Text = "+" & myItems.Item.Accuracy & " Accuracy"
        End If
        If myItems.Item.Damage = 0 Then
            lblDamage.Visible = False
        Else
            lblDamage.Visible = True
            lblDamage.Text = "+" & myItems.Item.Damage & " Damage"
        End If
        If myItems.Item.Defense = 0 Then
            lblDefense.Visible = False
        Else
            lblDefense.Visible = True
            lblDefense.Text = "+" & myItems.Item.Defense & " Defense"
        End If
        If myItems.Item.HealthToRestore = 0 Then
            lblHealthToRestore.Visible = False
        Else
            lblHealthToRestore.Visible = True
            lblHealthToRestore.Text = "Restores " & myItems.Item.HealthToRestore & " health."
        End If
        If myItems.Item.CriticalStrike = 0 Then
            lblCriticalStrike.Visible = False
        Else
            lblCriticalStrike.Visible = True
            lblCriticalStrike.Text = "+" & myItems.Item.CriticalStrike & " Critical Strike"
        End If
        If myItems.Item.Haste = 0 Then
            lblHaste.Visible = False
        Else
            lblHaste.Visible = True
            lblHaste.Text = "+" & myItems.Item.Haste & " Haste"
        End If
        If myItems.Item.Rate = 0 Then
            lblRate.Visible = False
        Else
            lblRate.Visible = True
            lblRate.Text = "Rate: " & myItems.Item.Rate
        End If
        If myItems.Item.DPS = 0 Then
            lblDPS.Visible = False
        Else
            lblDPS.Visible = True
            lblDPS.Text = "DPS: " & myItems.Item.DPS
        End If
        lblReqCoins.Text = myItems.Item.Coins
        lblReqDiamonds.Text = myItems.Item.Diamonds
        lblReqLevel.Text = myItems.Item.LevelRequired

        If myItems.Item.Coins <= myCoins And myItems.Item.Diamonds <= myDiamonds And myItems.Item.LevelRequired <= myLevel Then
            btnPurchase.Visible = True
        Else
            btnPurchase.Visible = False
        End If

        If itemType = ShopItem.Type.Weapon Then
            If Not myWeapon = Nothing Then
                myItems.ItemName = myWeapon
                continueExecution = True
            Else
                continueExecution = False
            End If
        ElseIf itemType = ShopItem.Type.Head Then
            If Not myHead = Nothing Then
                myItems.ItemName = myHead
                continueExecution = True
            Else
                continueExecution = False
            End If
        ElseIf itemType = ShopItem.Type.Chest Then
            If Not myChest = Nothing Then
                myItems.ItemName = myChest
                continueExecution = True
            Else
                continueExecution = False
            End If
        ElseIf itemType = ShopItem.Type.Legs Then
            If Not myLegs = Nothing Then
                myItems.ItemName = myLegs
                continueExecution = True
            Else
                continueExecution = False
            End If
        ElseIf itemType = ShopItem.Type.Feet Then
            If Not myFeet = Nothing Then
                myItems.ItemName = myFeet
                continueExecution = True
            Else
                continueExecution = False
            End If
        ElseIf itemType = ShopItem.Type.Consumable Then
            If Not myConsumable = Nothing Then
                myItems.ItemName = myConsumable
                continueExecution = True
            Else
                continueExecution = False
            End If
        ElseIf itemType = ShopItem.Type.Ammo Then
            If Not myBullet = Nothing Then
                myItems.ItemName = myBullet
                continueExecution = True
            Else
                continueExecution = False
            End If
        End If

        If continueExecution = True Then
            myItems.CheckItem()

            imgItem1.BackgroundImage = myItems.Item.Image
            lblName1.Text = myItems.Item.Title
            If myItems.Item.Health = 0 Then
                lblHealth1.Visible = False
            Else
                lblHealth1.Visible = True
                lblHealth1.Text = "+" & myItems.Item.Health & " Health"
            End If
            If myItems.Item.Accuracy = 0 Then
                lblAccuracy1.Visible = False
            Else
                lblAccuracy1.Visible = True
                lblAccuracy1.Text = "+" & myItems.Item.Accuracy & " Accuracy"
            End If
            If myItems.Item.Damage = 0 Then
                lblDamage1.Visible = False
            Else
                lblDamage1.Visible = True
                lblDamage1.Text = "+" & myItems.Item.Damage & " Damage"
            End If
            If myItems.Item.Defense = 0 Then
                lblDefense1.Visible = False
            Else
                lblDefense1.Visible = True
                lblDefense1.Text = "+" & myItems.Item.Defense & " Defense"
            End If
            If myItems.Item.HealthToRestore = 0 Then
                lblHealthToRestore1.Visible = False
            Else
                lblHealthToRestore1.Visible = True
                lblHealthToRestore1.Text = "Restores " & myItems.Item.HealthToRestore & " health."
            End If
            If myItems.Item.CriticalStrike = 0 Then
                lblCriticalStrike1.Visible = False
            Else
                lblCriticalStrike1.Visible = True
                lblCriticalStrike1.Text = "+" & myItems.Item.CriticalStrike & " Critical Strike"
            End If
            If myItems.Item.Haste = 0 Then
                lblHaste1.Visible = False
            Else
                lblHaste1.Visible = True
                lblHaste1.Text = "+" & myItems.Item.Haste & " Haste"
            End If
            If myItems.Item.Rate = 0 Then
                lblRate1.Visible = False
            Else
                lblRate1.Visible = True
                lblRate1.Text = "Rate: " & myItems.Item.Rate
            End If
            If myItems.Item.DPS = 0 Then
                lblDPS1.Visible = False
            Else
                lblDPS1.Visible = True
                lblDPS1.Text = "DPS: " & myItems.Item.DPS
            End If
        End If

    End Sub

    Public Sub ResetCurrentlyEquippedValues()
        lblName1.Text = ""
        imgItem1.BackgroundImage = Nothing
        lblHealth1.Text = ""
        lblHealthToRestore1.Text = ""
        lblRate1.Text = ""
        lblDPS1.Text = ""
        lblDamage1.Text = ""
        lblDefense1.Text = ""
        lblAccuracy1.Text = ""
        lblCriticalStrike1.Text = ""
        lblHaste1.Text = ""
    End Sub

    Private Sub btnPurchase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPurchase.Click
        If btnPurchase.Text = "Purchase" Then
            btnPurchase.Text = "Confirm?"
        ElseIf btnPurchase.Text = "Confirm?" Then
            ReplaceItems()

        End If
    End Sub

    Private Sub btnPurchase_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPurchase.MouseLeave
        btnPurchase.Text = "Purchase"
    End Sub

    Public Sub ReplaceItems()
        Dim previousName As String = ""
        Dim replace As Boolean

        If itemType = ShopItem.Type.Weapon Then
            If Not myWeapon = Nothing Then
                myItems.ItemName = myWeapon
                replace = True
            Else
                replace = False
            End If
        ElseIf itemType = ShopItem.Type.Head Then
            If Not myHead = Nothing Then
                myItems.ItemName = myHead
                replace = True
            Else
                replace = False
            End If

        ElseIf itemType = ShopItem.Type.Chest Then
            If Not myChest = Nothing Then
                myItems.ItemName = myChest
                replace = True
            Else
                replace = False
            End If
        ElseIf itemType = ShopItem.Type.Legs Then
            If Not myLegs = Nothing Then
                myItems.ItemName = myLegs
                replace = True
            Else
                replace = False
            End If
        ElseIf itemType = ShopItem.Type.Feet Then
            If Not myFeet = Nothing Then
                myItems.ItemName = myFeet
                replace = True
            Else
                replace = False
            End If
        ElseIf itemType = ShopItem.Type.Ammo Then
            If Not myBullet = Nothing Then
                myItems.ItemName = myBullet
                previousName = myBullet
                replace = True
            Else
                replace = False
            End If
        ElseIf itemType = ShopItem.Type.Consumable Then
            If Not myConsumable = Nothing Then
                myItems.ItemName = myConsumable
                previousName = myConsumable
                replace = True
            Else
                replace = False
            End If
        End If

        myItems.CheckItem()

        If replace = True Then
            myHealthValue -= myItems.Item.Health
            myHealthMax -= myItems.Item.Health
            myDamage -= myItems.Item.Damage
            myDefense -= myItems.Item.Defense
            myCriticalStrike -= myItems.Item.CriticalStrike
            myAccuracy -= myItems.Item.Accuracy
            myHaste -= myItems.Item.Haste
        End If

        myItems.ItemName = lbItems.SelectedItem
        myItems.CheckItem()

        itemType = myItems.Item.ItemType

        If itemType = ShopItem.Type.Weapon Then
            myWeapon = myItems.Item.Title
            myFireRate = myItems.Item.Rate * 1000
            MsgBox("You just purchased " & myWeapon)
        ElseIf itemType = ShopItem.Type.Head Then
            myHead = myItems.Item.Title
            MsgBox("You just purchased " & myHead)
        ElseIf itemType = ShopItem.Type.Chest Then
            myChest = myItems.Item.Title
            MsgBox("You just purchased " & myChest)
        ElseIf itemType = ShopItem.Type.Legs Then
            myLegs = myItems.Item.Title
            MsgBox("You just purchased " & myLegs)
        ElseIf itemType = ShopItem.Type.Feet Then
            myFeet = myItems.Item.Title
            MsgBox("You just purchased " & myFeet)
        ElseIf itemType = ShopItem.Type.Ammo Then
            myBullet = myItems.Item.Title
            If previousName = myItems.Item.Title Then
                myAmmo += 50
                MsgBox("You purchased 50 more ammo.")
            Else
                myAmmo = 50
                MsgBox("You purchased another bullet and reset your ammo value to 50.")
            End If
        ElseIf itemType = ShopItem.Type.Consumable Then
            myConsumable = myItems.Item.Title
            If previousName = myItems.Item.Title Then
                newAction.Image = myItems.Item.Image
                newAction.HealthToRestore = myItems.Item.HealthToRestore
                myConsumableAmount += 1
                newAction.btnAction.Text = myConsumableAmount
                newAction.btnAction.Enabled = True
                NewGame.newActionBar.Controls.Clear()
                NewGame.newActionBar.Controls.Add(newAction)
                MsgBox("You purchased another potion.")
            Else
                newAction.Image = myItems.Item.Image
                newAction.HealthToRestore = myItems.Item.HealthToRestore
                myConsumableAmount = 1
                newAction.btnAction.Text = myConsumableAmount
                newAction.btnAction.Enabled = True
                NewGame.newActionBar.Controls.Clear()
                NewGame.newActionBar.Controls.Add(newAction)
                MsgBox("You purchased a different potion and reset the amount of potions you hold to 1.")
            End If
        End If

        myCoins -= myItems.Item.Coins
        myDiamonds -= myItems.Item.Diamonds

        lblCoins.Text = myCoins
        lblDiamonds.Text = myDiamonds

        myHealthValue += myItems.Item.Health
        myHealthMax += myItems.Item.Health
        myDamage += myItems.Item.Damage
        myDefense += myItems.Item.Defense
        myCriticalStrike += myItems.Item.CriticalStrike
        myAccuracy += myItems.Item.Accuracy
        myHaste += myItems.Item.Haste

        ReturnItemValues()
    End Sub
End Class