﻿Imports Colour_Blocks.MainForm

Public Class StatsBar

    Public Sub UpdateValues()
        lblLevel.Text = myLevel
        If myHealthValue > myHealthMax Then
            myHealthValue = myHealthMax
        ElseIf myHealthValue <= 0 Then
            MainForm.AccessControl.Controls.Remove(NewGame.newStats)
            MainForm.AccessControl.Controls.Remove(NewGame.newExperienceBar)
            MainForm.AccessControl.Controls.Remove(NewGame.newActionBar)
            MainForm.GameContainer.Controls.Clear()
            For Each block As ColourBlock In NewGame.InGameBlocks
                block.PauseTimers()
            Next
            NewGame.InGameBlocks.Clear()
            MainForm.GameTimer.Enabled = False
            MainForm.CountdownTimer.Enabled = False
            MainForm.DeathTimer.Enabled = False
            MainForm.MenuContainer.Enabled = True
            MainForm.newResults.Dock = DockStyle.Fill
            MainForm.newResults.Show()
            MainForm.GameContainer.Controls.Add(MainForm.newResults)
            ExtraReward()
            myHealthValue = myHealthMax
            lblHealth.Text = myHealthValue
            Healthbar.Maximum = myHealthMax
            Healthbar.Value = myHealthValue
            If myCurrentExp >= myMaxExp Then
                Dim remainder As Integer = myCurrentExp - myMaxExp
                myLevel += 1
                myCurrentExp = remainder
                Levelling.CheckLevel()
                myHealthValue = myHealthMax
                lblHealth.Text = myHealthValue
                Healthbar.Maximum = myHealthMax
                Healthbar.Value = myHealthValue
            Else
                NewGame.newStats.lblLevel.Text = myLevel
                NewGame.newExperienceBar.Experience.Maximum = myMaxExp
                NewGame.newExperienceBar.Experience.Value = myCurrentExp
                NewGame.newExperienceBar.lblValue.Text = myCurrentExp
                NewGame.newExperienceBar.lblMax.Text = myMaxExp

            End If
        Else
            lblHealth.Text = myHealthValue
            Healthbar.Maximum = myHealthMax
            Healthbar.Value = myHealthValue

        End If

        lblCoins.Text = myCoins
        lblDiamonds.Text = myDiamonds
        lblAmmo.Text = myAmmo


    End Sub

    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click
        If btnPause.Text = "II" Then
            btnPause.Text = ">"
            For Each block As ColourBlock In NewGame.InGameBlocks
                block.PauseTimers()
            Next
            MainForm.GameTimer.Enabled = False
            MainForm.GameContainer.Enabled = False
            MainForm.DeathTimer.Enabled = False
            MainForm.CountdownTimer.Enabled = False
            MainForm.GameContainer.BackColor = Color.Gray
            MainForm.MenuContainer.Enabled = True
        Else
            btnPause.Text = "II"
            For Each block As ColourBlock In NewGame.InGameBlocks
                block.PlayTimers()
            Next
            MainForm.GameTimer.Enabled = True
            If NewGame.cmbGameMode.SelectedItem = "Timed" Then
                MainForm.CountdownTimer.Enabled = True
            End If

            If NewGame.cmbGameMode.SelectedItem = "Sudden Death" Then
                MainForm.DeathTimer.Enabled = True
            End If

            MainForm.GameContainer.Enabled = True
            MainForm.GameContainer.BackColor = Color.White
            MainForm.MenuContainer.Enabled = False
        End If
    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        For Each block As ColourBlock In NewGame.InGameBlocks
            block.PauseTimers()
        Next
        NewGame.InGameBlocks.Clear()
        myHealthValue = myHealthMax
        MainForm.GameTimer.Enabled = False
        MainForm.CountdownTimer.Enabled = False
        MainForm.DeathTimer.Enabled = False
        MainForm.AccessControl.Controls.Remove(NewGame.newStats)
        MainForm.AccessControl.Controls.Remove(NewGame.newExperienceBar)
        MainForm.AccessControl.Controls.Remove(NewGame.newActionBar)
        MainForm.GameContainer.Controls.Clear()
        MainForm.MenuContainer.Enabled = True
        MainForm.newResults.Dock = DockStyle.Fill
        MainForm.newResults.Show()
        MainForm.GameContainer.Controls.Add(MainForm.newResults)
        ExtraReward()

    End Sub


    Public Sub ExtraReward()
        If NewGame.cmbGameMode.SelectedItem = "Survival" Then
            MainForm.newResults.lblMode.Text = "Game Mode: Survival"
            MainForm.newResults.lblModeBonus.Text = "Blocks Destroyed: " & blocksDestroyed
            Dim percent As Decimal
            percent = blocksDestroyed
            MainForm.newResults.lblPercent.Text = "Percentage Bonus: " & percent & "%"
            percent = blocksDestroyed / 100
            Dim bonusCoins As Integer
            Dim bonusExp As Integer
            If myLevel = 20 Then
                bonusExp = 0
                bonusCoins = 0
            Else
                bonusExp = expCollected * (percent + 1)
                If bonusExp >= myLevel * 100 Then
                    bonusExp = myLevel * 100
                End If
                MainForm.newResults.lblBonusExp.Text = "Bonus Experience: " & bonusExp
                myCurrentExp += bonusExp

                bonusCoins = coinsCollected * (percent + 1)
                MainForm.newResults.lblBonusCoins.Text = "Bonus Coins: " & bonusCoins
                myCoins += bonusCoins

            End If


            bonusCoins = 0
            bonusExp = 0
            coinsCollected = 0
            expCollected = 0
            blocksDestroyed = 0
        ElseIf NewGame.cmbGameMode.SelectedItem = "Timed" Then
            MainForm.newResults.lblMode.Text = "Game Mode: Timed"
            MainForm.newResults.lblModeBonus.Text = "Time Spent: " & timeLasted & " minutes"
            Dim percent As Decimal
            percent = timeLasted
            MainForm.newResults.lblPercent.Text = "Percentage Bonus: " & (percent * 10) & "%"
            percent = timeLasted / 10
            Dim bonusCoins As Integer
            Dim bonusExp As Integer
            If myLevel = 20 Then
                bonusExp = 0
                bonusCoins = 0
            Else
                bonusExp = expCollected * (percent + 1)
                If bonusExp >= myLevel * 100 Then
                    bonusExp = myLevel * 100
                End If
                MainForm.newResults.lblBonusExp.Text = "Bonus Experience: " & bonusExp
                myCurrentExp += bonusExp

                bonusCoins = coinsCollected * (percent + 1)
                MainForm.newResults.lblBonusCoins.Text = "Bonus Coins: " & bonusCoins
                myCoins += bonusCoins

            End If


            bonusCoins = 0
            bonusExp = 0
            coinsCollected = 0
            expCollected = 0
            timeLasted = 0

        ElseIf NewGame.cmbGameMode.SelectedItem = "Sudden Death" Then
            MainForm.newResults.lblMode.Text = "Game Mode: Sudden Death"
            MainForm.newResults.lblModeBonus.Text = "Death Avoided: " & deathAvoided
            Dim percent As Decimal
            percent = deathAvoided * 2
            MainForm.newResults.lblPercent.Text = "Percentage Bonus: " & (percent * 10) & "%"
            percent = deathAvoided / 10
            Dim bonusCoins As Integer
            Dim bonusExp As Integer
            If myLevel = 20 Then
                bonusExp = 0
                bonusCoins = 0
            Else
                bonusExp = expCollected * (percent + 1)
                If bonusExp >= myLevel * 100 Then
                    bonusExp = myLevel * 100
                End If
                MainForm.newResults.lblBonusExp.Text = "Bonus Experience: " & bonusExp
                myCurrentExp += bonusExp

                bonusCoins = coinsCollected * (percent + 1)
                MainForm.newResults.lblBonusCoins.Text = "Bonus Coins: " & bonusCoins
                myCoins += bonusCoins

            End If


            bonusCoins = 0
            bonusExp = 0
            coinsCollected = 0
            expCollected = 0
            deathAvoided = 0

        End If


    End Sub
End Class
